--    ======================
--    Description
--    ======================
--
--    Logika umożliwia uzależnienie wyjścia od wejścia na podstawie podanej listy punktów. Np. zachowanie wyjścia analogowego w zależności od temperatury:
--
--    input: -100     output: 95
--    input: 0        output: 90
--    input: 100      output: 80
--    input: 150      output: 70
--    input: 200      output: 50
--    input: 250      output: 50
--    input: 300      output: 70
--
--    ======================
--    Parameters
--    ======================
--
--    SubLogic supports following variables:
--
--    input                                   - wejście - temperatura
--
--    output                                  - stan wyjścia
--
--    counter.points.no                       - ilość punktów zależności "points"
--
--    setting.option                           - w jaki sposób ma być ustalana wartość wyjścia dla wartości pośrednich spoza listy "points":
--                                               0: wartość brzegowa niższa z listy setting.point.input
--                                               1: wartość brzegowa wyższa z listy setting.point.input
--
--    setting.point.input                     - lista "points" - wartość wejścia
--
--    setting.point.output                    - lista "points" - wartość wyjścia
--
--    Logic uses lua language to implement own behaviour
--
--    ======================
--    mandatory variables
--    ======================
--
--    Logic expects following mandatory variables:
--
--    reload.trigger                          - causes reloading lua script
--
--    memcnt                                  - current amount of memory used by lua in bytes
--
--    Logic expects following kv settings:
--
--    LuaScriptPath                           - path to the lua script - must be absolute
--
--    ======================
--    ChangeLog
--    ======================
--
--    2023-01-04 ver 1.0.0
--
--    # First release
--
-- user can use some functions provided by ibmanager.

-- ibmanager provides following functions to use:
--
-- function returns value of required ibmanager variable
-- @param fullName - string - variable name - name of variable of which value must be returned, for example "rs.0.id.255.input.t.0.value"
-- @return         - string or integer - variable value or "nil" if variable not exist or is not readable
--
-- getValue(fullName)


-- function set value of given ibmanager variable
-- @param fullName - string - variable name - name of variable of which value we want to set, for example "rs.0.id.255.input.t.0.value"
-- @param value    - string, int or boolean - value to set
-- @return         - nothing
--
-- setValue(fullName, value)


-- function returns value of required ibmanager variable
-- @param key      - placed in xml logic configuration file:
--                   * as attribute: Name, in Var, RemoteVar and ImportVar elements in the case of stand alone variables
--                   * as concatenation of two attributes: ListName.Postfix in VarListItem, RemoteVarListItem and ImportVarListItem elements
--                     in the case of variables that are placed in lists
-- @return         - string or integer - variable value or "nil" if variable not exist or is not readable
--
-- getLogicValue(key)


-- function set value of given ibmanager variable
-- @param key      - placed in xml logic configuration file:
--                   * as attribute: Name, in Var, RemoteVar and ImportVar elements in the case of stand alone variables
--                   * as concatenation of two attributes: ListName.Postfix in VarListItem, RemoteVarListItem and ImportVarListItem elements
--                     in the case of variables that are placed in lists
-- @param value    - string, int or boolean - value to set
-- @return         - nothing
--
-- setLogicValue(key, value)

-- function returns two sections of kvsettings from xml configuration file
-- returned value is two element table, each of these elements is table too.
-- indices of returned table are strings and equal "instance" and "global"
-- values of returned tables are tables and contain KVsettings for applicable section.
-- nested tables have form key = value, where key is index in nested table and value is value.
-- example: {"instance" = {"ikey1" = "ivalue1", "ikey2" = "gvalue2"}, "global" = {"gkey1" = "gvalue1", "gkey2" = "gvalue2", "gkey3" = "gvalue3"}}
-- @return          - two dimensional array - kvsettings for global and instance sections
-- getKvSettings()


-- function schedules alert to send.
-- rules are defined in separated alert configuration files and are described in ibmanager instruction manual
-- @param id - alert identifier - must be defined in current logic configuration file in section: <Alert Id="any_identifier" ...
-- scheduleAlert(id)

-- function cancels alert sending, if was previously scheduled. if not then only wakes up alerts handling thread, so if there is no need to call this function, then do not call it.
-- rules are defined in separated alert configuration files and are described in ibmanager instruction manual
-- @param id - alert identifier - must be defined in current logic configuration file in section: <Alert Id="any_identifier" ...
-- cancelAlert(name)

-- function returns table, containing Variables that belongs to required list.
-- @param listName - Name attribute of VarList, RemoteVarList or ImportVarList elemetnst in configurationfile
-- @return array of key-value pairs. Key - variable postfix, Value - Variable value
-- getVarList(listName)

-- function returns monotonic system clock value, that elapsed since specific epoch
-- returned time is expressed in milliseconds.
-- getClock()

-- function logs message to file, if defined in configuration file log level is less than passed to this function
-- @param logLevel - one of:
--        LogLevel.TraceLo
--        LogLevel.Trace
--        LogLevel.TraceHi
--        LogLevel.DebugLo
--        LogLevel.Debug
--        LogLevel.DebugHi
--        LogLevel.Info
--        LogLevel.Notice
--        LogLevel.Warning
--        LogLevel.Error
--        LogLevel.Critical
-- @param logMessage - string to log
-- log(logLevel, logMessage)


-- ibmanager provides following global variables:

-- logic type, (in this case it will always be "Lua") - the same as in logic configuration file in section: <Logic Type="Lua" ...
-- LOGIC_TYPE

-- logic version, the same as in logic configuration file in section: <Logic ... Version="x.y.z" ...
-- LOGIC_VERSION

-- logic sub-type, the same as in logic configuration file in section: <Logic ... SubType="Hysteresis" ...
-- LOGIC_SUBTYPE

-- logic sub-version, the same as in logic configuration file in section: <Logic ... SubVersion="x.y.z" ...
-- LOGIC_SUBVERSION

-- logic instance name - the same as in logic configuration file, in section: <Instance Name="0">
-- LOGIC_INSTANCE_NAME

-- add script directory to package path
package.path = package.path .. ";./logic/scripts/utils/?.lua";

-- use script - without .lua extension - delta class
require("DownCounter");
require("Functions");

SUPPORTED_SUBLOGIC_TYPE = "FunctionCurve";
SUPPORTED_SUBLOGIC_VERSION = "1.0.0";
g_versionChecked = false;

g_pointsCount = 0;
g_checkList = 0;

g_tablePointsPostfix = {};

g_settingInputOld = {};
g_settingInput = {};
g_settingOutput = {};

-- zwraca 1 jeżeli listy są OK
function checkLists()
  local fail = false

  if (g_pointsCount == 0) then
    log(LogLevel.Error, "VarList setting.id not initialized in instance section of configuration.")
    fail = true
  else
    for i = 0, g_pointsCount-1, 1 do

      -- Check for fail

      for j = i+1, g_pointsCount-1, 1 do
        if g_settingInput[g_tablePointsPostfix[i]] == g_settingInput[g_tablePointsPostfix[j]] then
          log(LogLevel.Error, "In initialization section element found duplicated values for list element setting.point.input: " .. g_settingInput[g_tablePointsPostfix[i]] .. ".")
          fail = true
        end
      end

      if g_settingInput[g_tablePointsPostfix[i]] then
      else
        log(LogLevel.Error, "VarList element setting.point.input." .. g_tablePointsPostfix[i] .. " not initialized in instance section of configuration.")
        fail = true
      end

      if g_settingOutput[g_tablePointsPostfix[i]] then
      else
        log(LogLevel.Error, "VarList element setting.point.output." .. g_tablePointsPostfix[i] .. " not initialized in instance section of configuration.")
        fail = true
      end

    end
  end

  if fail then
    return 0
  else
    return 1
  end

end

function readAll(file)
    local f = assert(io.open(file, "rb"))
    local content = f:read("*all")
    f:close()
    return content
end

-- entry point to the logic
function onLogicCall(firstCall)

  if not g_versionChecked then
    -- checking sublogic type and sublogic version
    if LOGIC_SUBTYPE ~= SUPPORTED_SUBLOGIC_TYPE then
      error("Wrong logic sub-type. expected " .. SUPPORTED_SUBLOGIC_TYPE .. " but used " .. LOGIC_SUBTYPE);
    end
    local versionWithoutBuild = string.match(LOGIC_SUBVERSION, "[0-9]+%.[0-9]+%.[0-9]+");
    if versionWithoutBuild ~= SUPPORTED_SUBLOGIC_VERSION then
      error("Wrong logic sub-version. expected " .. SUPPORTED_SUBLOGIC_VERSION .. " but used " .. LOGIC_SUBVERSION);
    end
    g_versionChecked = true;
  end

  local input                            = getLogicValue("input");
  local settingOption                    = getLogicValue("setting.option");

  local settingPointInput                = getVarList("setting.point.input");
  local settingPointOutput               = getVarList("setting.point.output");

  local output

  local i = 0;
  g_pointsCount = 0;

  g_settingInputOld = copyObj(g_settingInput)

  -- tablica
  if settingPointInput ~= nil then
    for postfix, value in pairs(settingPointInput) do
      g_settingInput['' .. postfix] = value;

      g_tablePointsPostfix[g_pointsCount] = postfix
      g_pointsCount = g_pointsCount + 1;

    end
  end

  -- tablica
  if settingPointOutput ~= nil then
    for postfix, value in pairs(settingPointOutput) do
      g_settingOutput['' .. postfix] = value;
    end
  end

  if (firstCall) then
    g_checkList = checkLists()
  end

  output = 0

  -- jeżeli znaleziono duplikat wartości w g_settingInput to przywróć wcześniejsze ustawienia i wyjdź
  if not uniqueValues(g_settingInput) then
    log(LogLevel.Warning, 'Found duplicate! Reversing to previous valid settings.')
    for i = 0, g_pointsCount-1, 1 do
      --print(g_tablePointsPostfix[i], g_settingInput[g_tablePointsPostfix[i]], g_settingInputOld[g_tablePointsPostfix[i]])
      setLogicValue("setting.point.input." .. g_tablePointsPostfix[i], g_settingInputOld[g_tablePointsPostfix[i]]);
    end
    return
  end

  if g_checkList == 1 then

    --print('=================');
    --print('input: ' .. input);


    if (settingOption == 0) then

      local prev_prefix = -1
      local changed = false

      for postfix, value in pairsByValues(g_settingInput) do
        i = tonumber(getKeyByValue(g_tablePointsPostfix, postfix))
        --print(i, g_tablePointsPostfix[i], g_settingInput[g_tablePointsPostfix[i]], g_settingOutput[g_tablePointsPostfix[i]], prev_prefix);

        if (input == g_settingInput[g_tablePointsPostfix[i]]) then
          output = g_settingOutput[g_tablePointsPostfix[i]]
          changed = true
          break
        end

        if (input < g_settingInput[g_tablePointsPostfix[i]]) then

          if (prev_prefix ~= -1) then
            output = g_settingOutput[g_tablePointsPostfix[prev_prefix]]
            changed = true
          else
            output = g_settingOutput[g_tablePointsPostfix[i]]
            changed = true
          end

          break
        end

        prev_prefix = i
      end

      if not changed then
        output = g_settingOutput[g_tablePointsPostfix[i]]
      end

    elseif (settingOption == 1) then

      local changed = false

      for postfix, value in pairsByValues(g_settingInput) do
        i = tonumber(getKeyByValue(g_tablePointsPostfix, postfix))
        --print(i, g_tablePointsPostfix[i], g_settingInput[g_tablePointsPostfix[i]], g_settingOutput[g_tablePointsPostfix[i]], prev_prefix);

        if (input == g_settingInput[g_tablePointsPostfix[i]]) then
          output = g_settingOutput[g_tablePointsPostfix[i]]
          changed = true
          break
        end

        if (input < g_settingInput[g_tablePointsPostfix[i]]) then
          output = g_settingOutput[g_tablePointsPostfix[i]]
          changed = true
          break
        end

      end

      if not changed then
        output = g_settingOutput[g_tablePointsPostfix[i]]
      end

    else
      log(LogLevel.Error, 'Unsupported setting.option: ' .. settingOption .. '. Changing to default value: 0')
      setLogicValue("setting.option", 0);
    end

    --print('output: ' .. output);

    setLogicValue("output", output);
    setLogicValue("counter.points.no", g_pointsCount);
  else
    setLogicValue("output", output);
    setLogicValue("counter.points.no", 0);
  end

end
